# PyQGIS
from qgis.PyQt.QtCore import QMargins, QPoint, QRect, QSize, Qt
from qgis.PyQt.QtWidgets import QLayout, QSizePolicy, QWidget


class FlowLayout(QLayout):
    """From https://doc.qt.io/qtforpython-6/examples/example_widgets_layouts_flowlayout.html
    Dynamic "flow" layout. Width and height are adapted according to the number of items in the layout
    """

    def __init__(self, parent=None):
        super().__init__(parent)

        if parent is not None:
            self.setContentsMargins(QMargins(0, 0, 0, 0))

        self._item_list = []

    def __del__(self):
        item = self.takeAt(0)
        while item:
            item = self.takeAt(0)

    def addItem(self, item: QWidget) -> None:
        """Add an item to the layout

        :param item: item to be added
        :type item: QWidget
        """
        self._item_list.append(item)

    def count(self) -> int:
        """Count number of items in the layout"""
        return len(self._item_list)

    def itemAt(self, index) -> QWidget:
        """Return item (at index) in the layout

        :param index: item in the layout
        :type index: int
        """
        if 0 <= index < len(self._item_list):
            return self._item_list[index]

        return None

    def takeAt(self, index) -> QWidget:
        """Return item (at index) in the layout, and pop it from the list

        :param index: item in the layout
        :type index: int
        """
        if 0 <= index < len(self._item_list):
            return self._item_list.pop(index)

        return None

    def expandingDirections(self) -> Qt.Orientation:
        """Override expandingDirections method"""
        return Qt.Orientation(0)

    def hasHeightForWidth(self) -> bool:
        """Override hasHeightForWidth method"""
        return True

    def heightForWidth(self, width) -> int:
        """Override heightForWidth method
        Calculate height from width

        :param width: width available
        :type width: int
        """
        height = self._do_layout(QRect(0, 0, width, 0), True)
        return height

    def setGeometry(self, rect) -> None:
        """Call setGeometry and _do_layout methods

        :param rect: widget geometry
        :type rect: QRect
        """
        super(FlowLayout, self).setGeometry(rect)
        self._do_layout(rect, False)

    def sizeHint(self) -> QSize:
        """Get minimum size of layout"""
        return self.minimumSize()

    def minimumSize(self) -> QSize:
        """Calculate minimun size available"""
        size = QSize()

        for item in self._item_list:
            size = size.expandedTo(item.minimumSize())

        size += QSize(
            2 * self.contentsMargins().top(), 2 * self.contentsMargins().top()
        )
        return size

    def _do_layout(self, rect: QRect, test_only: bool) -> int:
        """Render the layout

        :param rect: widget geometry
        :type rect: QRect
        :param test_only: apply or not the layout
        :type test_only: bool
        """
        x = rect.x()
        y = rect.y()
        line_height = 0
        spacing = self.spacing()
        for item in self._item_list:
            style = item.widget().style()
            layout_spacing_x = style.layoutSpacing(
                QSizePolicy.ControlType.PushButton,
                QSizePolicy.ControlType.PushButton,
                Qt.Orientation.Horizontal,
            )
            layout_spacing_y = style.layoutSpacing(
                QSizePolicy.ControlType.PushButton,
                QSizePolicy.ControlType.PushButton,
                Qt.Orientation.Vertical,
            )
            space_x = spacing + layout_spacing_x
            space_y = spacing + layout_spacing_y
            next_x = x + item.sizeHint().width() + space_x
            if next_x - space_x > rect.right() and line_height > 0:
                x = rect.x()
                y = y + line_height + space_y
                next_x = x + item.sizeHint().width() + space_x
                line_height = 0

            if not test_only:
                item.setGeometry(QRect(QPoint(x, y), item.sizeHint()))

            x = next_x
            line_height = max(line_height, item.sizeHint().height())

        return y + line_height - rect.y()
